Index: lemon/random.cc
===================================================================
--- lemon/random.cc	(revision 10)
+++ lemon/random.cc	(revision 16)
@@ -25,5 +25,5 @@
   /// \brief Global random number generator instance
   ///
-  /// A global mersenne twister random number generator instance
+  /// A global Mersenne Twister random number generator instance.
   Random rnd;
 }
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 12)
+++ lemon/random.h	(revision 16)
@@ -74,6 +74,4 @@
 ///\file
 ///\brief Mersenne Twister random number generator
-///
-///\author Balazs Dezso
 
 namespace lemon {
@@ -517,10 +515,8 @@
   /// good programming convenience to use this global generator to get
   /// random numbers.
-  ///
-  /// \author Balazs Dezso
   class Random {
   private:
 
-    // architecture word
+    // Architecture word
     typedef unsigned long Word;
     
@@ -724,6 +720,6 @@
     /// Gauss distribution with given mean and standard deviation
 
+    /// Gauss distribution with given mean and standard deviation
     /// \sa gauss()
-    ///
     double gauss(double mean,double std_dev)
     {
@@ -815,4 +811,7 @@
     
     /// Uniform distribution on the full unit circle.
+
+    /// Uniform distribution on the full unit circle.
+    ///
     dim2::Point<double> disc() 
     {
Index: lemon/tolerance.h
===================================================================
--- lemon/tolerance.h	(revision 7)
+++ lemon/tolerance.h	(revision 16)
@@ -49,7 +49,11 @@
   ///\sa Tolerance<long double>
   ///\sa Tolerance<int>
+#if defined __GNUC__ && !defined __STRICT_ANSI__  
   ///\sa Tolerance<long long int>
+#endif
   ///\sa Tolerance<unsigned int>
+#if defined __GNUC__ && !defined __STRICT_ANSI__  
   ///\sa Tolerance<unsigned long long int>
+#endif
 
   template<class T>
@@ -131,5 +135,5 @@
     bool negative(Value a) const { return -_epsilon>a; }
     ///Returns \c true if \c a is \e surely non-zero
-    bool nonZero(Value a) const { return positive(a)||negative(a); };
+    bool nonZero(Value a) const { return positive(a)||negative(a); }
 
     ///@}
@@ -182,5 +186,5 @@
     bool negative(Value a) const { return -_epsilon>a; }
     ///Returns \c true if \c a is \e surely non-zero
-    bool nonZero(Value a) const { return positive(a)||negative(a); };
+    bool nonZero(Value a) const { return positive(a)||negative(a); }
 
     ///@}
@@ -233,5 +237,5 @@
     bool negative(Value a) const { return -_epsilon>a; }
     ///Returns \c true if \c a is \e surely non-zero
-    bool nonZero(Value a) const { return positive(a)||negative(a); };
+    bool nonZero(Value a) const { return positive(a)||negative(a); }
 
     ///@}
@@ -266,5 +270,5 @@
     static bool negative(Value a) { return 0>a; }
     ///Returns \c true if \c a is \e surely non-zero
-    static bool nonZero(Value a) { return a!=0; };
+    static bool nonZero(Value a) { return a!=0; }
 
     ///@}
@@ -299,5 +303,5 @@
     static bool negative(Value) { return false; }
     ///Returns \c true if \c a is \e surely non-zero
-    static bool nonZero(Value a) { return a!=0; };
+    static bool nonZero(Value a) { return a!=0; }
 
     ///@}
@@ -333,5 +337,5 @@
     static bool negative(Value a) { return 0>a; }
     ///Returns \c true if \c a is \e surely non-zero
-    static bool nonZero(Value a) { return a!=0;};
+    static bool nonZero(Value a) { return a!=0;}
 
     ///@}
@@ -366,5 +370,5 @@
     static bool negative(Value) { return false; }
     ///Returns \c true if \c a is \e surely non-zero
-    static bool nonZero(Value a) { return a!=0;};
+    static bool nonZero(Value a) { return a!=0;}
 
     ///@}
@@ -403,5 +407,5 @@
     static bool negative(Value a) { return 0>a; }
     ///Returns \c true if \c a is \e surely non-zero
-    static bool nonZero(Value a) { return a!=0;};
+    static bool nonZero(Value a) { return a!=0;}
 
     ///@}
@@ -438,5 +442,5 @@
     static bool negative(Value) { return false; }
     ///Returns \c true if \c a is \e surely non-zero
-    static bool nonZero(Value a) { return a!=0;};
+    static bool nonZero(Value a) { return a!=0;}
 
     ///@}