Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 225)
+++ CMakeLists.txt	(revision 236)
@@ -6,5 +6,5 @@
 #  OUTPUT_STRIP_TRAILING_WHITESPACE)
 
-SET(PROJECT_NAME "Lemon")
+SET(PROJECT_NAME "LEMON")
 SET(PROJECT_VERSION_MAJOR "0")
 SET(PROJECT_VERSION_MINOR "99")
@@ -37,5 +37,5 @@
     "EGRES - Egervary Research Group on Combinatorial Optimization")
   SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY
-    "Lemon - Library of Efficient Models and Optimization in Networks")
+    "LEMON - Library of Efficient Models and Optimization in Networks")
   SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE")
 
@@ -58,7 +58,7 @@
 
   #SET(CPACK_COMPONENT_HEADERS_DESCRIPTION
-  #  "C++ header files for use with the Lemon library")
+  #  "C++ header files for use with the LEMON library")
   #SET(CPACK_COMPONENT_LIBRARY_DESCRIPTION
-  #  "Static library used to build programs with Lemon")
+  #  "Static library used to build programs with LEMON")
   #SET(CPACK_COMPONENT_HTML_DOCUMENTATION_DESCRIPTION
   #  "Doxygen generated documentation")
@@ -71,7 +71,7 @@
 
   #SET(CPACK_COMPONENT_GROUP_DEVELOPMENT_DESCRIPTION
-  #  "Components needed to develop software using Lemon")
+  #  "Components needed to develop software using LEMON")
   #SET(CPACK_COMPONENT_GROUP_DOCUMENTATION_DESCRIPTION
-  #  "Documentation of Lemon")
+  #  "Documentation of LEMON")
 
   #SET(CPACK_ALL_INSTALL_TYPES Full Developer)
Index: configure.ac
===================================================================
--- configure.ac	(revision 226)
+++ configure.ac	(revision 236)
@@ -7,5 +7,5 @@
 
 AC_PREREQ([2.59])
-AC_INIT([Lemon], [lemon_version()], [lemon-user@lemon.cs.elte.hu], [lemon])
+AC_INIT([LEMON], [lemon_version()], [lemon-user@lemon.cs.elte.hu], [lemon])
 AC_CONFIG_AUX_DIR([build-aux])
 AC_CONFIG_MACRO_DIR([m4])
Index: doc/groups.dox
===================================================================
--- doc/groups.dox	(revision 210)
+++ doc/groups.dox	(revision 236)
@@ -326,5 +326,5 @@
 maximum cardinality matching.
 
-Lemon contains the next algorithms:
+LEMON contains the next algorithms:
 - \ref lemon::MaxBipartiteMatching "MaxBipartiteMatching" Hopcroft-Karp
   augmenting path algorithm for calculate maximum cardinality matching in
@@ -477,10 +477,10 @@
 
 /**
-@defgroup lemon_io Lemon Input-Output
+@defgroup lemon_io LEMON Input-Output
 @ingroup io_group
-\brief Reading and writing \ref lgf-format "Lemon Graph Format".
+\brief Reading and writing \ref lgf-format "LEMON Graph Format".
 
 This group describes methods for reading and writing
-\ref lgf-format "Lemon Graph Format".
+\ref lgf-format "LEMON Graph Format".
 */
 
Index: doc/lgf.dox
===================================================================
--- doc/lgf.dox	(revision 212)
+++ doc/lgf.dox	(revision 236)
@@ -22,5 +22,5 @@
 
 
-\page lgf-format Lemon Graph Format (LGF)
+\page lgf-format LEMON Graph Format (LGF)
 
 The \e LGF is a <em>column oriented</em>
Index: lemon/bits/alteration_notifier.h
===================================================================
--- lemon/bits/alteration_notifier.h	(revision 230)
+++ lemon/bits/alteration_notifier.h	(revision 236)
@@ -42,5 +42,5 @@
   ///
   /// The graph's node and edge sets can be changed as we add or erase
-  /// nodes and edges in the graph. Lemon would like to handle easily
+  /// nodes and edges in the graph. LEMON would like to handle easily
   /// that the node and edge maps should contain values for all nodes or
   /// edges. If we want to check on every indicing if the map contains
Index: lemon/concepts/path.h
===================================================================
--- lemon/concepts/path.h	(revision 220)
+++ lemon/concepts/path.h	(revision 236)
@@ -78,5 +78,5 @@
       void clear() {}
 
-      /// \brief Lemon style iterator for path arcs
+      /// \brief LEMON style iterator for path arcs
       ///
       /// This class is used to iterate on the arcs of the paths.
@@ -201,5 +201,5 @@
     /// If we would like to give back a real path from these
     /// algorithms then we should create a temporarly path object. In
-    /// Lemon such algorithms gives back a path dumper what can
+    /// LEMON such algorithms gives back a path dumper what can
     /// assigned to a real path and the dumpers can be implemented as
     /// an adaptor class to the predecessor map.
@@ -233,5 +233,5 @@
       typedef False RevPathTag;
 
-      /// \brief Lemon style iterator for path arcs
+      /// \brief LEMON style iterator for path arcs
       ///
       /// This class is used to iterate on the arcs of the paths.
@@ -260,5 +260,5 @@
       };
 
-      /// \brief Lemon style iterator for path arcs
+      /// \brief LEMON style iterator for path arcs
       ///
       /// This class is used to iterate on the arcs of the paths in
Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 220)
+++ lemon/lgf_reader.h	(revision 236)
@@ -19,5 +19,5 @@
 ///\ingroup lemon_io
 ///\file
-///\brief \ref lgf-format "Lemon Graph Format" reader.
+///\brief \ref lgf-format "LEMON Graph Format" reader.
 
 
@@ -2302,5 +2302,5 @@
   ///
   /// This class can be used to read the sections, the map names and
-  /// the attributes from a file. Usually, the Lemon programs know
+  /// the attributes from a file. Usually, the LEMON programs know
   /// that, which type of graph, which maps and which attributes
   /// should be read from a file, but in general tools (like glemon)
Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 220)
+++ lemon/lgf_writer.h	(revision 240)
@@ -19,5 +19,5 @@
 ///\ingroup lemon_io
 ///\file
-///\brief \ref lgf-format "Lemon Graph Format" writer.
+///\brief \ref lgf-format "LEMON Graph Format" writer.
 
 
@@ -935,5 +935,5 @@
     bool local_os;
 
-    Graph& _graph;
+    const Graph& _graph;
 
     std::string _nodes_caption;
Index: lemon/list_graph.h
===================================================================
--- lemon/list_graph.h	(revision 235)
+++ lemon/list_graph.h	(revision 239)
@@ -843,5 +843,7 @@
 
     public:
-      operator Edge() const { return edgeFromId(id / 2); }
+      operator Edge() const { 
+        return id != -1 ? edgeFromId(id / 2) : INVALID; 
+      }
 
       Arc() {}
Index: lemon/path.h
===================================================================
--- lemon/path.h	(revision 220)
+++ lemon/path.h	(revision 236)
@@ -83,5 +83,5 @@
     }
 
-    /// \brief Lemon style iterator for path arcs
+    /// \brief LEMON style iterator for path arcs
     ///
     /// This class is used to iterate on the arcs of the paths.
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 220)
+++ lemon/smart_graph.h	(revision 238)
@@ -466,5 +466,7 @@
 
     public:
-      operator Edge() const { return edgeFromId(_id / 2); }
+      operator Edge() const { 
+        return _id != -1 ? edgeFromId(_id / 2) : INVALID; 
+      }
 
       Arc() {}
Index: lemon/unionfind.h
===================================================================
--- lemon/unionfind.h	(revision 220)
+++ lemon/unionfind.h	(revision 236)
@@ -498,5 +498,5 @@
     }
 
-    /// \brief Lemon style iterator for the representant items.
+    /// \brief LEMON style iterator for the representant items.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -550,5 +550,5 @@
     };
 
-    /// \brief Lemon style iterator for the items of a component.
+    /// \brief LEMON style iterator for the items of a component.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -808,5 +808,5 @@
     }
 
-    /// \brief Lemon style iterator for the classes.
+    /// \brief LEMON style iterator for the classes.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -860,5 +860,5 @@
     };
 
-    /// \brief Lemon style iterator for the items of a component.
+    /// \brief LEMON style iterator for the items of a component.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates
@@ -1656,5 +1656,5 @@
     }
 
-    /// \brief Lemon style iterator for the items of a class.
+    /// \brief LEMON style iterator for the items of a class.
     ///
     /// ClassIt is a lemon style iterator for the components. It iterates